Description

RFC non-compliant emission causes Mail::Field::IncompleteParseError while performing email delivery and breaks email notification.
No email notifications are delivered if Setting.mail_from has an RFC non-compliant value. The problem occurs in r17870 or later.

[ActiveJob] [ActionMailer::DeliveryJob] [f5bd6903-4£3f-4f40-9d%a-36ab998126e8] Error performing Ac
tionMailer::DeliveryJob (Job ID: f5bd6903-4f3f-4f40-9d9%9a-36ab9%998126e8) from Async(mailers) in 1.2m
s: Mail::Field::IncompleteParseError (Mail::AddressList can not parse |Redmine[xyz] <redmine@examp
le.com>|: Only able to parse up to "Redmine"):

To avoid this, | think a validation for Setting.mail_from that rejects RFC non-compliant value should be implemented. It can be
implemented using Mail::Address.new.

irb(main) :001:0> Mail::Address.new ('Redmine[xyz] <redmine@example.com>")

Traceback (most recent call last):

Mail::Field::IncompleteParseError (Mail::AddressList can not parse |Redmine[xyz] <redmine@example.
com>|: Only able to parse up to "Redmine")

Related issues:
Related to Redmine - Feature #5913: Authors name in from address of email no... Closed 2010-07-20

Associated revisions

Revision 18396 - 2019-08-26 06:18 - Go MAEDA

Reject setting RFC non-compliant emission email addresses (#31154).

Patch by Mizuki ISHIKAWA.

Revision 18434 - 2019-09-05 09:22 - Go MAEDA

Fix that test_mail_from_format_should_be_validated randomly fails (#31154).

Patch by Yuichi HARADA.

History

#1 - 2019-04-07 04:05 - Go MAEDA

- Related to Feature #5913: Authors name in from address of email notifications added

#2 - 2019-04-09 01:36 - Go MAEDA

A workaround for this issue is committed in r18050. Redmine works as same as before r17870 and never raises an exception when the emission
email address is not RFC compliant.

But | think this proposed validation is still necessary. Redmine should make an effort not to send emails which violates RFC.

#3 - 2019-07-09 07:01 - Mizuki ISHIKAWA
- File feature-31154.patch added

This patch adds validation of the mail_from value.

e Mail::Address.new(mail_from) does not return an exception
¢ Mail::Address.new(mail_from).adress matches EmailAddress::EMAIL_REGEXP
#4 - 2019-07-09 07:37 - Marius BALTEANU
Mizuki ISHIKAWA wrote:
This patch adds validation of the mail_from value.
e Mail::Address.new(mail_from) does not return an exception

¢ Mail::Address.new(mail_from).adress matches EmailAddress::EMAIL_REGEXP

Mizuki, do you see any problem if we use the existing EMAIL_REGEXP regex from URI::MailTo? https:/www.rubydoc.info/stdlib/uri/URI/MailTo

#5 - 2019-07-09 08:58 - Mizuki ISHIKAWA
Marius BALTEANU wrote:

Mizuki ISHIKAWA wrote:
This patch adds validation of the mail_from value.
® Mail::Address.new(mail_from) does not return an exception

e Mail::Address.new(mail_from).adress matches EmailAddress::EMAIL_REGEXP

Mizuki, do you see any problem if we use the existing EMAIL_REGEXP regex from URI::MailTo? https://www.rubydoc.info/stdlib/uri/URI/MailTo

| agree to use URI::MailTo::EMAIL_REGEXP because URI::MailTo::EMAIL_REGEXP is often used.
However, | think that it is better to hear other people's opinions because | am not familiar with e-mail address validation rules.

#6 - 2019-07-31 09:26 - Go MAEDA
Marius BALTEANU wrote:

Mizuki, do you see any problem if we use the existing EMAIL_REGEXP regex from URI::MailTo? https://www.rubydoc.info/stdlib/uri/URI/MailTo

URI::MailTo::EMAIL_REGEXP cannot be used for Redmine because it rejects email addresses with Unicode characters such as "00000 jp"
(000000 means "domain name example" in Japanese). Jean-Philippe Lang wrote in #15985#note-3 that Redmine should not reject domain names
with non-ASCII characters.
Go MAEDA wrote:
Non-ASClI characters cannot be used in an email address.

Yes, they can. More and more clients and server support that.
We cannot simply disallow them in Redmine.

If you have any intarest in the support for Unicode domain (IDN), please see also #29208.

#7 - 2019-08-11 09:01 - Go MAEDA

- Target version set to 4.1.0
Setting the target version to 4.1.0.

#8 - 2019-08-26 06:18 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed
Committed the patch. Thank you.

#9 - 2019-08-27 06:18 - Go MAEDA

- Status changed from Closed to Reopened

The test sometimes fails:

$ bin/rails test —--seed 64692

2025-07-14 2/3


https://www.rubydoc.info/stdlib/uri/URI/MailTo
https://www.rubydoc.info/stdlib/uri/URI/MailTo
https://www.rubydoc.info/stdlib/uri/URI/MailTo
https://www.redmine.org/issues/15985#note-3
https://www.redmine.org/issues/29208

(snip)

Failure:

SettingTest#test_mail_from_format_should_be_validated [/Users/maeda/redmines/redmine-trunk/test/unit/setting_t
est.rb:140]:

Expected [[:mail_from, "n'est pas valide"]] to include [:mail_from, "is invalid"].

#10 - 2019-09-05 07:43 - Yuichi HARADA
Go MAEDA wrote:

The test sometimes fails:

(-]

| think ::118n.locale was set to 'fr' in other tests. | think it will be solved with this patch.

diff --git a/test/unit/setting_test.rb b/test/unit/setting_test.rb
index 253£3c037..145961539 100644
—-—— a/test/unit/setting_test.rb
+++ b/test/unit/setting_test.rb
@@ -20,6 +20,7 @@
require File.expand_path('../../test_helper', _ FILE_ )

class SettingTest < ActiveSupport::TestCase
+ fixtures :users

def setup
User.current = nil
@@ -134,7 +135,7 @@ YAML
end

def test_mail_from_format_should_be_validated

= with_settings :default_language => 'en' do
+ with_locale 'en' do
['[Redmine app] <redmine@example.net>', 'redmine'].each do |invalid_mail_from|
errors = Setting.set_all_from params ({:mail_from => invalid_mail_from})
assert_includes errors, [:mail_from, 'is invalid']

#11 - 2019-09-05 09:23 - Go MAEDA

- Status changed from Reopened to Closed

Yuichi HARADA wrote:
Go MAEDA wrote:
The test sometimes fails:

(-]

I think ::118n.locale was set to 'fr' in other tests. | think it will be solved with this patch.

(-]

Committed the fix in r18434. Thanks.

Files
feature-31154.patch 2.33 KB 2019-07-09 Mizuki ISHIKAWA
